<?php
namespace FORM4\Form4Pages\Controller;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014 form4 GmbH & Co. KG <typo3@form4.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 *
 *
 * @author	Johannes Härtner <johannes.haertner@form4.de>
 * @package form4_pages
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class PageController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController {

	/**
	 * largePageRepository
	 *
	 * @var \FORM4\Form4Pages\Domain\Repository\LargePageRepository
	 * @inject
	 */
	protected $largePageRepository;


	/**
	 * standardRepository
	 *
	 * @var \FORM4\Form4Pages\Domain\Repository\StandardRepository
	 * @inject
	 */
	protected $standardRepository;


	/**
	 * externalRepository
	 *
	 * @var \FORM4\Form4Pages\Domain\Repository\ExternalRepository
	 * @inject
	 */
	protected $externalRepository;

	/**
	 * shortcutRepository
	 *
	 * @var \FORM4\Form4Pages\Domain\Repository\ShortcutRepository
	 * @inject
	 */
	protected $shortcutRepository;

	/**
	 * doktypeManager
	 *
	 * @var \FORM4\Form4Pages\Helper\DoktypeManager
	 * @inject
	 */
	protected $doktypeManager;

	/**
	 * action list
	 *
	 * @return void
	 */
	public function listAction() {
		$pages = $this->largePageRepository->findAll();
		$this->view->assign('pages', $pages);
	}

	/**
	 * action list
	 *
	 * @return void
	 */
	public function listStandardAction() {
		$pages = $this->standardRepository->findAll();
		$this->view->assign('pages', $pages);
	}

	/**
	 * action list
	 *
	 * @return void
	 */
	public function listShortcutAction() {
		$pages = $this->shortcutRepository->findAll();
		$this->view->assign('pages', $pages);
	}

	/**
	 * action list
	 *
	 * @return void
	 */
	public function listExternalAction() {
		$pages = $this->externalRepository->findAll();
		$this->view->assign('pages', $pages);
	}

	/**
	 * action list
	 *
	 * @return void
	 */
	public function doktypeManagerAction() {
		$pages = $this->doktypeManager->findAll();
		$this->view->assign('pages', $pages);
	}


}
?>