<?php

namespace FORM4\Form4Pages\Domain\Model;

/***************************************************************
 * Copyright notice
 *
 * (c) 2014 form4 GmbH & Co. KG <typo3@form4.de>
 * All rights reserved
 *
 * This script is part of the TYPO3 project. The TYPO3 project is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 * This script is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * This copyright notice MUST APPEAR in all copies of the script!
 * **************************************************************/

/**
 *
 * @author Johannes Härtner <johannes.haertner@form4.de>
 * @package form4_pages
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
abstract class AbstractLargePage extends \FORM4\Form4Pages\Domain\Model\AbstractPage {

	/**
	 * navTitle
	 *
	 * @var \string
	 */
	protected $navTitle;

	/**
	 * subtitle
	 *
	 * @var \string
	 */
	protected $subtitle;

	/**
	 * media
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference>
	 * @lazy
	 */
	protected $media;

	/**
	 * navHide
	 *
	 * @var boolean
	 */
	protected $navHide = FALSE;

	/**
	 * hidden
	 *
	 * @var boolean
	 */
	protected $hidden = FALSE;

	/**
	 * starttime
	 *
	 * @var \DateTime
	 */
	protected $starttime;

	/**
	 * endtime
	 *
	 * @var \DateTime
	 */
	protected $endtime;

	/**
	 * extendToSubpages
	 *
	 * @var boolean
	 */
	protected $extendToSubpages = FALSE;

	/**
	 * feGroup
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FrontendUserGroup>
	 * @lazy
	 */
	protected $feGroup;

	/**
	 * feLoginMode
	 *
	 * @var \integer
	 */
	protected $feLoginMode;

	/**
	 * abstract
	 *
	 * @var \string
	 */
	protected $abstract;

	/**
	 * keywords
	 *
	 * @var \string
	 */
	protected $keywords;

	/**
	 * description
	 *
	 * @var \string
	 */
	protected $description;

	/**
	 * author
	 *
	 * @var \string
	 */
	protected $author;

	/**
	 * authorEmail
	 *
	 * @var \string
	 */
	protected $authorEmail;

	/**
	 * lastUpdated
	 *
	 * @var \DateTime
	 */
	protected $lastUpdated;

	/**
	 * layout
	 *
	 * @var \integer
	 */
	protected $layout;

	/**
	 * backendLayout
	 *
	 * @var \integer
	 */
	protected $backendLayout;

	/**
	 * backendLayoutNextLevel
	 *
	 * @var \integer
	 */
	protected $backendLayoutNextLevel;

	/**
	 * newUntil
	 *
	 * @var \DateTime
	 */
	protected $newUntil;

	/**
	 * contentFromPid
	 *
	 * @var \FORM4\Form4Pages\Domain\Model\LargePage
	 * @lazy
	 */
	protected $contentFromPid;

	/**
	 * alias
	 *
	 * @var \string
	 */
	protected $alias;

	/**
	 * target
	 *
	 * @var \string
	 */
	protected $target;

	/**
	 * storagePid
	 *
	 * @var \FORM4\Form4Pages\Domain\Model\LargePage
	 */
	protected $storagePid;

	/**
	 * shortcutMode
	 *
	 * @var \integer
	 */
	protected $shortcutMode;

	/**
	 * shortcut
	 *
	 * @var \FORM4\Form4Pages\Domain\Model\LargePage
	 * @lazy
	 */
	protected $shortcut;

	/**
	 * urltype
	 *
	 * @var \string
	 */
	protected $urltype;

	/**
	 * urlScheme
	 *
	 * @var \string
	 */
	protected $urlScheme;

	/**
	 * url
	 *
	 * @var \string
	 */
	protected $url;

	/**
	 * crdate
	 *
	 * @var \DateTime
	 */
	protected $crdate;

	/**
	 * tstamp
	 *
	 * @var \DateTime
	 */
	protected $tstamp;

	/**
	 * permsUserid
	 *
	 * @var \integer
	 */
	protected $permsUserid;

	/**
	 * permsGroupid
	 *
	 * @var \integer
	 */
	protected $permsGroupid;

	/**
	 * permsUser
	 *
	 * @var \integer
	 */
	protected $permsUser;

	/**
	 * permsGroup
	 *
	 * @var \integer
	 */
	protected $permsGroup;

	/**
	 * permsEverybody
	 *
	 * @var \integer
	 */
	protected $permsEverybody;

	/**
	 * cruserId
	 *
	 * @var \integer
	 */
	protected $cruserId;

	/**
	 * Categories
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\Category>
	 */
	protected $categories;



	/**
	 * __construct
	 *
	 * @return Dummy
	 */
	public function __construct() {
		// Do not remove the next line: It would break the functionality
		$this->initStorageObjects ();
	}

	/**
	 * Initializes all ObjectStorage properties.
	 *
	 * @return void
	 */
	protected function initStorageObjects() {
		/**
		 * Do not modify this method!
		 * It will be rewritten on each save in the extension builder
		 * You may modify the constructor of this class instead
		 */
		$this->media = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage ();
		$this->feGroup = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage ();
		$this->category = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage ();
	}

	/**
	 * Returns the navTitle
	 *
	 * @return \string $navTitle
	 */
	public function getNavTitle() {
		return $this->navTitle;
	}

	/**
	 * Sets the navTitle
	 *
	 * @param \string $navTitle
	 * @return void
	 */
	public function setNavTitle($navTitle) {
		$this->navTitle = $navTitle;
	}

	/**
	 * Returns the subtitle
	 *
	 * @return \string $subtitle
	 */
	public function getSubtitle() {
		return $this->subtitle;
	}

	/**
	 * Sets the urltype
	 *
	 * @param \string $urltype
	 * @return void
	 */
	public function setUrltype($urltype) {
		$this->urltype = $urltype;
	}

	/**
	 * Adds a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $medium
	 * @return void
	 */
	public function addMedium(\TYPO3\CMS\Extbase\Domain\Model\FileReference $medium) {
		$this->media->attach ( $medium );
	}

	/**
	 * Removes a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $mediumToRemove
	 * The FileReference to be removed
	 * @return void
	 */
	public function removeMedium(\TYPO3\CMS\Extbase\Domain\Model\FileReference $mediumToRemove) {
		$this->media->detach ( $mediumToRemove );
	}

	/**
	 * Returns the media
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $media
	 */
	public function getMedia() {
		return $this->media;
	}

	/**
	 * Sets the media
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $media
	 * @return void
	 */
	public function setMedia(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $media) {
		$this->media = $media;
	}

	/**
	 * Returns the navHide
	 *
	 * @return boolean $navHide
	 */
	public function getNavHide() {
		return $this->navHide;
	}

	/**
	 * Sets the navHide
	 *
	 * @param boolean $navHide
	 * @return void
	 */
	public function setNavHide($navHide) {
		$this->navHide = $navHide;
	}

	/**
	 * Returns the boolean state of navHide
	 *
	 * @return boolean
	 */
	public function isNavHide() {
		return $this->getNavHide ();
	}

	/**
	 * Returns the hidden
	 *
	 * @return boolean $hidden
	 */
	public function getHidden() {
		return $this->hidden;
	}

	/**
	 * Sets the hidden
	 *
	 * @param boolean $hidden
	 * @return void
	 */
	public function setHidden($hidden) {
		$this->hidden = $hidden;
	}

	/**
	 * Returns the boolean state of hidden
	 *
	 * @return boolean
	 */
	public function isHidden() {
		return $this->getHidden ();
	}

	/**
	 * Returns the starttime
	 *
	 * @return \DateTime $starttime
	 */
	public function getStarttime() {
		return $this->starttime;
	}

	/**
	 * Sets the starttime
	 *
	 * @param \DateTime $starttime
	 * @return void
	 */
	public function setStarttime($starttime) {
		$this->starttime = $starttime;
	}

	/**
	 * Returns the endtime
	 *
	 * @return \DateTime $endtime
	 */
	public function getEndtime() {
		return $this->endtime;
	}

	/**
	 * Sets the endtime
	 *
	 * @param \DateTime $endtime
	 * @return void
	 */
	public function setEndtime($endtime) {
		$this->endtime = $endtime;
	}

	/**
	 * Returns the extendToSubpages
	 *
	 * @return boolean $extendToSubpages
	 */
	public function getExtendToSubpages() {
		return $this->extendToSubpages;
	}

	/**
	 * Sets the extendToSubpages
	 *
	 * @param boolean $extendToSubpages
	 * @return void
	 */
	public function setExtendToSubpages($extendToSubpages) {
		$this->extendToSubpages = $extendToSubpages;
	}

	/**
	 * Returns the boolean state of extendToSubpages
	 *
	 * @return boolean
	 */
	public function isExtendToSubpages() {
		return $this->getExtendToSubpages ();
	}

	/**
	 * Adds a FrontendUserGroup
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FrontendUserGroup $feGroup
	 * @return void
	 */
	public function addFeGroup(\TYPO3\CMS\Extbase\Domain\Model\FrontendUserGroup $feGroup) {
		$this->feGroup->attach ( $feGroup );
	}

	/**
	 * Removes a FrontendUserGroup
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FrontendUserGroup $feGroupToRemove
	 *        	The FrontendUserGroup to be removed
	 * @return void
	 */
	public function removeFeGroup(\TYPO3\CMS\Extbase\Domain\Model\FrontendUserGroup $feGroupToRemove) {
		$this->feGroup->detach ( $feGroupToRemove );
	}

	/**
	 * Returns the feGroup
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FrontendUserGroup> $feGroup
	 */
	public function getFeGroup() {
		return $this->feGroup;
	}

	/**
	 * Sets the feGroup
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FrontendUserGroup> $feGroup
	 * @return void
	 */
	public function setFeGroup(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $feGroup) {
		$this->feGroup = $feGroup;
	}

	/**
	 * Returns the feLoginMode
	 *
	 * @return \integer $feLoginMode
	 */
	public function getFeLoginMode() {
		return $this->feLoginMode;
	}

	/**
	 * Sets the feLoginMode
	 *
	 * @param \integer $feLoginMode
	 * @return void
	 */
	public function setFeLoginMode($feLoginMode) {
		$this->feLoginMode = $feLoginMode;
	}

	/**
	 * Returns the abstract
	 *
	 * @return \string $abstract
	 */
	public function getAbstract() {
		return $this->abstract;
	}

	/**
	 * Sets the abstract
	 *
	 * @param \string $abstract
	 * @return void
	 */
	public function setAbstract($abstract) {
		$this->abstract = $abstract;
	}

	/**
	 * Returns the keywords
	 *
	 * @return \string $keywords
	 */
	public function getKeywords() {
		return $this->keywords;
	}

	/**
	 * Sets the keywords
	 *
	 * @param \string $keywords
	 * @return void
	 */
	public function setKeywords($keywords) {
		$this->keywords = $keywords;
	}

	/**
	 * Returns the description
	 *
	 * @return \string $description
	 */
	public function getDescription() {
		return $this->description;
	}

	/**
	 * Sets the description
	 *
	 * @param \string $description
	 * @return void
	 */
	public function setDescription($description) {
		$this->description = $description;
	}

	/**
	 * Returns the author
	 *
	 * @return \string $author
	 */
	public function getAuthor() {
		return $this->author;
	}

	/**
	 * Sets the author
	 *
	 * @param \string $author
	 * @return void
	 */
	public function setAuthor($author) {
		$this->author = $author;
	}

	/**
	 * Returns the authorEmail
	 *
	 * @return \string $authorEmail
	 */
	public function getAuthorEmail() {
		return $this->authorEmail;
	}

	/**
	 * Sets the authorEmail
	 *
	 * @param \string $authorEmail
	 * @return void
	 */
	public function setAuthorEmail($authorEmail) {
		$this->authorEmail = $authorEmail;
	}

	/**
	 * Returns the lastUpdated
	 *
	 * @return \DateTime $lastUpdated
	 */
	public function getLastUpdated() {
		return $this->lastUpdated;
	}

	/**
	 * Sets the lastUpdated
	 *
	 * @param \DateTime $lastUpdated
	 * @return void
	 */
	public function setLastUpdated($lastUpdated) {
		$this->lastUpdated = $lastUpdated;
	}

	/**
	 * Returns the layout
	 *
	 * @return \integer $layout
	 */
	public function getLayout() {
		return $this->layout;
	}

	/**
	 * Sets the layout
	 *
	 * @param \integer $layout
	 * @return void
	 */
	public function setLayout($layout) {
		$this->layout = $layout;
	}

	/**
	 * Returns the backendLayout
	 *
	 * @return \integer $backendLayout
	 */
	public function getBackendLayout() {
		return $this->backendLayout;
	}

	/**
	 * Sets the backendLayout
	 *
	 * @param \integer $backendLayout
	 * @return void
	 */
	public function setBackendLayout($backendLayout) {
		$this->backendLayout = $backendLayout;
	}

	/**
	 * Returns the backendLayoutNextLevel
	 *
	 * @return \integer $backendLayoutNextLevel
	 */
	public function getBackendLayoutNextLevel() {
		return $this->backendLayoutNextLevel;
	}

	/**
	 * Sets the backendLayoutNextLevel
	 *
	 * @param \integer $backendLayoutNextLevel
	 * @return void
	 */
	public function setBackendLayoutNextLevel($backendLayoutNextLevel) {
		$this->backendLayoutNextLevel = $backendLayoutNextLevel;
	}

	/**
	 * Returns the newUntil
	 *
	 * @return \DateTime $newUntil
	 */
	public function getNewUntil() {
		return $this->newUntil;
	}

	/**
	 * Sets the newUntil
	 *
	 * @param \DateTime $newUntil
	 * @return void
	 */
	public function setNewUntil($newUntil) {
		$this->newUntil = $newUntil;
	}

	/**
	 * Returns the contentFromPid
	 *
	 * @return \FORM4\Form4Pages\Domain\Model\LargePage $contentFromPid
	 */
	public function getContentFromPid() {
		return $this->contentFromPid;
	}

	/**
	 * Sets the contentFromPid
	 *
	 * @param \FORM4\Form4Pages\Domain\Model\LargePage $contentFromPid
	 * @return void
	 */
	public function setContentFromPid(\FORM4\Form4Pages\Domain\Model\LargePage $contentFromPid) {
		$this->contentFromPid = $contentFromPid;
	}

	/**
	 * Returns the alias
	 *
	 * @return \string $alias
	 */
	public function getAlias() {
		return $this->alias;
	}

	/**
	 * Sets the alias
	 *
	 * @param \string $alias
	 * @return void
	 */
	public function setAlias($alias) {
		$this->alias = $alias;
	}

	/**
	 * Returns the target
	 *
	 * @return \string $target
	 */
	public function getTarget() {
		return $this->target;
	}

	/**
	 * Sets the target
	 *
	 * @param \string $target
	 * @return void
	 */
	public function setTarget($target) {
		$this->target = $target;
	}

	/**
	 * Returns the storagePid
	 *
	 * @return \FORM4\Form4Pages\Domain\Model\LargePage $storagePid
	 */
	public function getStoragePid() {
		return $this->storagePid;
	}

	/**
	 * Sets the storagePid
	 *
	 * @param \FORM4\Form4Pages\Domain\Model\LargePage $storagePid
	 * @return void
	 */
	public function setStoragePid(\FORM4\Form4Pages\Domain\Model\LargePage $storagePid) {
		$this->storagePid = $storagePid;
	}

	/**
	 * Sets the shortcutMode
	 *
	 * @param \integer $shortcutMode
	 * @return void
	 */
	public function setShortcutMode($shortcutMode) {
		$this->shortcutMode = $shortcutMode;
	}

	/**
	 * Returns the shortcut
	 *
	 * @return \FORM4\Form4Pages\Domain\Model\LargePage $shortcut
	 */
	public function getShortcut() {
		return $this->shortcut;
	}

	/**
	 * Sets the shortcut
	 *
	 * @param \FORM4\Form4Pages\Domain\Model\LargePage $shortcut
	 * @return void
	 */
	public function setShortcut(\FORM4\Form4Pages\Domain\Model\LargePage $shortcut) {
		$this->shortcut = $shortcut;
	}

	/**
	 * Sets the subtitle
	 *
	 * @param \string $subtitle
	 * @return void
	 */
	public function setSubtitle($subtitle) {
		$this->subtitle = $subtitle;
	}

	/**
	 * Returns the urltype
	 *
	 * @return \string $urltype
	 */
	public function getUrltype() {
		return $this->urltype;
	}

	/**
	 * Returns the url
	 *
	 * @return \string $url
	 */
	public function getUrl() {
		return $this->url;
	}

	/**
	 * Sets the url
	 *
	 * @param \string $url
	 * @return void
	 */
	public function setUrl($url) {
		$this->url = $url;
	}

	/**
	 * Returns the urlScheme
	 *
	 * @return \string $urlScheme
	 */
	public function getUrlScheme() {
		return $this->urlScheme;
	}

	/**
	 * Sets the urlScheme
	 *
	 * @param \string $urlScheme
	 * @return void
	 */
	public function setUrlScheme($urlScheme) {
		$this->urlScheme = $urlScheme;
	}

	/**
	 * Returns the crdate
	 *
	 * @return \DateTime $crdate
	 */
	public function getCrdate() {
		return $this->crdate;
	}

	/**
	 * Sets the crdate
	 *
	 * @param \DateTime $crdate
	 * @return void
	 */
	public function setCrdate($crdate) {
		$this->crdate = $crdate;
	}

	/**
	 * Returns the tstamp
	 *
	 * @return \DateTime $tstamp
	 */
	public function getTstamp() {
		return $this->tstamp;
	}

	/**
	 * Sets the tstamp
	 *
	 * @param \DateTime $tstamp
	 * @return void
	 */
	public function setTstamp($tstamp) {
		$this->tstamp = $tstamp;
	}

	/**
	 * Returns the permsUserid
	 *
	 * @return \integer $permsUserid
	 */
	public function getPermsUserid() {
		return $this->permsUserid;
	}

	/**
	 * Sets the permsUserid
	 *
	 * @param \integer $permsUserid
	 * @return void
	 */
	public function setPermsUserid($permsUserid) {
		$this->permsUserid = $permsUserid;
	}

	/**
	 * Returns the permsGroupid
	 *
	 * @return \integer $permsGroupid
	 */
	public function getPermsGroupid() {
		return $this->permsGroupid;
	}

	/**
	 * Sets the permsGroupid
	 *
	 * @param \integer $permsGroupid
	 * @return void
	 */
	public function setPermsGroupid($permsGroupid) {
		$this->permsGroupid = $permsGroupid;
	}

	/**
	 * Returns the permsUser
	 *
	 * @return \integer $permsUser
	 */
	public function getPermsUser() {
		return $this->permsUser;
	}

	/**
	 * Sets the permsUser
	 *
	 * @param \integer $permsUser
	 * @return void
	 */
	public function setPermsUser($permsUser) {
		$this->permsUser = $permsUser;
	}

	/**
	 * Returns the permsGroup
	 *
	 * @return \integer $permsGroup
	 */
	public function getPermsGroup() {
		return $this->permsGroup;
	}

	/**
	 * Sets the permsGroup
	 *
	 * @param \integer $permsGroup
	 * @return void
	 */
	public function setPermsGroup($permsGroup) {
		$this->permsGroup = $permsGroup;
	}

	/**
	 * Returns the permsEverybody
	 *
	 * @return \integer $permsEverybody
	 */
	public function getPermsEverybody() {
		return $this->permsEverybody;
	}

	/**
	 * Sets the permsEverybody
	 *
	 * @param \integer $permsEverybody
	 * @return void
	 */
	public function setPermsEverybody($permsEverybody) {
		$this->permsEverybody = $permsEverybody;
	}

	/**
	 * Returns the cruserId
	 *
	 * @return \integer $cruserId
	 */
	public function getCruserId() {
		return $this->cruserId;
	}

	/**
	 * Sets the cruserId
	 *
	 * @param \integer $cruserId
	 * @return void
	 */
	public function setCruserId($cruserId) {
		$this->cruserId = $cruserId;
	}
	/**
	 * Adds a Category
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\Category $category
	 * @return void
	 */
	public function addCategory(\TYPO3\CMS\Extbase\Domain\Model\Category $category) {
		$this->category->attach ( $category );
	}

	/**
	 * Removes a Category
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\Category $categoryToRemove
	 *        	The Category to be removed
	 * @return void
	 */
	public function removeCategory(\TYPO3\CMS\Extbase\Domain\Model\Category $categoryToRemove) {
		$this->category->detach ( $categoryToRemove );
	}

	/**
	 * Returns the categories
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\Category> $categories
	 */
	public function getCategories() {
		return $this->categories;
	}

	/**
	 * Sets the category
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\Category> $categories
	 * @return void
	 */
	public function setCategories(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $categories) {
		$this->categories = $categories;
	}
}
?>